#include	<algorithm>
#include	<iostream>
#include	<dirent.h>
#include	<cstdlib>
#include	<cstring>
#include	<fstream>
#include	<vector>
#include	<string>
using	namespace	std;

void	print_one(string&	F){
	char	buffer[1024];
	ifstream	fi(F.c_str());
	if(!fi)	return;
	for(fi.getline(buffer,	1024);	!fi.eof();	fi.getline(buffer,	1024)){
		char	*p=strstr(buffer,	"fprintf(stderr,	\"\\n");
		if(p==NULL)	continue;
		for(p+=19;	p<buffer+1024;	p++){
			if(*p=='"'){	printf("\n");	break;	}
			if(*p=='\\'){	printf("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");	break;	}
			putchar(*p);
		}
	}
	fi.close();
}	

int	main(void){
	vector<string>	name;
	
	DIR	*dir=opendir(".");
	if(dir==NULL){	fprintf(stderr,	"can't open current directory\n");	return	0;	}
	struct	dirent  *ptr;
	while((ptr=readdir(dir))!=NULL){
		string	s=ptr->d_name;	uint	len=s.size();
		if(len>4&&s[len-4]=='.'&&s[len-3]=='c'&&s[len-2]=='p'&&s[len-1]=='p')	
			name.push_back(s);
	}
	closedir(dir);
	sort(name.begin(),	name.end());
	
	cout<<"SNPTools:	pileline for NGS SNP analysis\n";
	cout<<"author	Yi Wang @ Fuli Yu' Group\n";
	cout<<"Baylor College of Medicine Human Genome Sequencing Center.\n";
	cout<<"All rights reserved.\n\n";
	cout<<"Workflow summary:\n\n";
	cout<<"bamqc->pileup->snprob->snpcall\n";
	cout<<"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
		
	for(uint	i=0;	i<name.size();	i++)	print_one(name[i]);
			
	cout<<"Installation\n";
	cout<<"User should install GSL first.\n";
	cout<<"Ubuntu: sudo apt-get install libgsl0-dev\n";
	cout<<"If GSL is not installed in default directory, please modify makefile:\n";
	cout<<"Add -Ixxx/GSL/include after INCLUDE=\n";
	cout<<"Add -Lxxx/GSL/lib after LIBS=\n\n";
	cout<<"The software is based on samtools's API library: libbam.a\n";
	cout<<"User should enter 'samtools' directory and type the following two commands:\n";
	cout<<"	make clean\n";
	cout<<"	make\n\n";
	cout<<"Finally go back to 'source' directory and type\n";
	cout<<"	make\n\n";
	cout<<"Email yw2@bcm.edu if you meet installation problems.\n";
	cout<<"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
	cout<<"License\n";
	cout<<"Permission is hereby granted, free of charge, to any person obtaining a copy\n";
	cout<<"of this software and associated documentation files (the 'Software'), to deal\n";
	cout<<"in the Software without restriction, including without limitation the rights\n";
	cout<<"to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n";
	cout<<"copies of the Software, and to permit persons to whom the Software is\n";
	cout<<"furnished to do so, subject to the following conditions:\n\n";
	cout<<"The above copyright notice and this permission notice shall be included in\n";
	cout<<"all copies or substantial portions of the Software.\n\n";
	cout<<"THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n";
	cout<<"IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n";
	cout<<"FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n";
	cout<<"AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n";
	cout<<"LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n";
	cout<<"OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\n";
	cout<<"THE SOFTWARE.\n";
	return	0;
}
